<?php

namespace STM\DB\Object\Helpers;

use STM\DB\SQL\Condition;
use \Exception;

/**
 * Test class for TableQuery.
 * Generated by PHPUnit on 2013-07-06 at 13:16:40.
 * @group database
 */
class TableQueryTest extends \PHPUnit_Framework_TestCase
{

    /** @var string */
    private $tableName;
    /** @var array */
    private $primaryKey;
    /** @var array */
    private $pkValues;
    /** @var TableQuery */
    private $object;

    protected function setUp()
    {
        $this->tableName = DT_CLUBS_MEMBERS;
        $this->primaryKey = array('id_club', 'id_person', 'id_position');
        $this->pkValues = array('club' => 'Makov', 'person' => 'Zdenda', 'position' => 'Developer');
        $this->object = new TableQuery($this->tableName, $this->primaryKey);
    }

    public function testGetEmptyInsertQuery()
    {
        $query = $this->object->getEmptyInsertQuery();
        // inserted values must be specified
        parent::assertFalse($query->generate());
        $query->addAttributes(array('attribute' => 'value'));
        parent::assertTrue(is_int(strpos($query->generate(), 'INSERT INTO ' . $this->tableName)));
    }

    public function testGetEmptyUpdateQuery()
    {
        $query = $this->object->getEmptyUpdateQuery();
        // updates values must be specified and where condition must be set
        parent::assertFalse($query->generate());
        $query->addAttributes(array('attribute' => 'value'));
        $query->setWhere(new Condition('id = 1'));
        parent::assertTrue(is_int(strpos($query->generate(), 'UPDATE ' . $this->tableName)));
    }

    public function testGetEmptyDeleteQuery()
    {
        $query = $this->object->getEmptyDeleteQuery();
        // where condition must be set
        parent::assertFalse($query->generate());
        $query->setWhere(new Condition('id = 1'));
        parent::assertTrue(is_int(strpos($query->generate(), 'DELETE FROM ' . $this->tableName)));
    }

    public function testGetConditionPK()
    {
        $condition = $this->object->getConditionPK($this->pkValues);
        parent::assertTrue($condition->isValid());
        parent::assertEquals(
            "id_club = 'Makov' AND id_person = 'Zdenda' AND id_position = 'Developer'",
            $condition->__toString()
        );
        // numbers of values and attributes in PK must match
        try {
            $this->object->getConditionPK(array());
            parent::fail('Test should fail');
        } catch (Exception $e) {
            parent::assertInstanceOf('InvalidArgumentException', $e);
        }
    }

    public function testSelectByPK()
    {
        $query = $this->object->selectByPK($this->pkValues);
        parent::assertTrue($query->isValid());
        parent::assertEquals(
            "SELECT * FROM {$this->tableName}  WHERE id_club = 'Makov' AND id_person = 'Zdenda' AND id_position = 'Developer'",
            trim($query->generate())
        );
    }

    public function testSelect()
    {
        $query = $this->object->select();
        parent::assertTrue($query->isValid());
        parent::assertTrue(is_int(strpos($query->generate(), 'SELECT * FROM ' . $this->tableName)));
    }

    public function testCountRows()
    {
        $query = $this->object->countRows(new Condition('a = b'));
        parent::assertTrue($query->isValid());
        parent::assertTrue(is_int(strpos($query->generate(), 'count(*)')));
        parent::assertTrue(is_int(strpos($query->generate(), 'WHERE')));
    }

    public function testCountRowsInTable()
    {
        $query = $this->object->countRowsInTable();
        parent::assertTrue($query->isValid());
        parent::assertTrue(is_int(strpos($query->generate(), 'count(*)')));
        parent::assertFalse(strpos($query->generate(), 'WHERE'));
    }

    public function testExistsRow()
    {
        $query = $this->object->existsRow(array('name', 'city'), array('Zdenda', 'Makov'));
        parent::assertTrue($query->isValid());
        parent::assertTrue(is_int(strpos($query->generate(), "LOWER(name) = 'zdenda'")));
        parent::assertTrue(is_int(strpos($query->generate(), "LOWER(city) = 'makov'")));
        // case-INsensitive -> values are lowercased
        parent::assertFalse(strpos($query->generate(), 'Zdenda'));
        parent::assertFalse(strpos($query->generate(), 'Makov'));
    }

}

?>
